﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace TestModelFirst
{
   using System;
   using System.Collections.Generic;

   public class Customers
   {
      public Customers()
      {
         // Automatically obtain a list of purchases from the database.
         this.Purchases = new HashSet<Purchases>();
      }

      // Define an delegate to signfy that a customer has been created.
      public delegate void NameAccess(object sender, NameArgs e);

      // Define an event.
      public event NameAccess NameAccessed;

      // Declare the table properties.
      public int Id { get; set; }

      private String _CustomerName;
      public string CustomerName
      {
         get
         {
            // Tell everyone there has been name access.
            if (this.NameAccessed != null)
               this.NameAccessed(this, 
                  new NameArgs { Name = this._CustomerName, IsGet = true });

            // Return the default value.
            return _CustomerName;
         }

         set
         {
            // Tell everyone there has been name access.
            if (this.NameAccessed != null)
               this.NameAccessed(this, 
                  new NameArgs { Name = this._CustomerName, IsGet = false });

            // Set the default value.
            _CustomerName = value;
         }
      }

      // Declare the navigational property.
      public virtual ICollection<Purchases> Purchases { get; set; }
   }

   // A custom event arguments class used to define access target and type.
   public class NameArgs : EventArgs
   {
      // Defines the customer's name.
      public string Name { get; set; }

      // Determines whether this is a get or a set.
      public bool IsGet { get; set; }
   }
}
