﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace TestModelFirst
{
   public partial class Form1 : Form
   {
      public Form1()
      {
         InitializeComponent();
      }

      private void btnAdd_Click(object sender, EventArgs e)
      {
         // Create a new purchase.
         Purchases NewPurchase = new Purchases();
         NewPurchase.Amount = new Decimal(5.99);
         NewPurchase.PurchaseDate = DateTime.Now;

         // Create a new customer and add the purchase.
         Customers NewCustomer = new Customers();
         NewCustomer.CustomerName = "Josh Bailey";

         // Create the context.
         Rewards2ModelContainer context = new Rewards2ModelContainer();

         // Add the record and save it.
         context.Customers.Add(NewCustomer);
         context.Purchases.Add(NewPurchase);
         context.SaveChanges();

         // Display a success message.
         MessageBox.Show("Record Added");
      }

      private void btnQuery_Click(object sender, EventArgs e)
      {
          // Create the context.
          Rewards2ModelContainer context = new Rewards2ModelContainer();

          // Obtain the customer list.
          var CustomerList =
              from cust in context.Customers
              select cust;

          //// Obtain the customer list in list form.
          //List<Customers> CustomerList =
          //    (from cust in context.Customers
          //     select cust).ToList<Customers>();

          // Process each customer in the list.
          StringBuilder Output = 
              new StringBuilder("Customer List:");
          foreach (var Customer in CustomerList)
          {
              // Create a customer entry for each customer.
              Output.Append("\r\n" + Customer.CustomerName + 
                  " has made purchases on: ");

              // Process each purchase for that particular customer.
              foreach (var Purchase in Customer.Purchases)
                  Output.Append("\r\n\t" + Purchase.PurchaseDate);
          }

          // Display the result on screen.
          MessageBox.Show(Output.ToString());
      }

      private void bntQuery2_Click(object sender, EventArgs e)
      {
         // Create the context.
         Rewards2ModelContainer context = new Rewards2ModelContainer();

         // Obtain the customer list.
         var CustomerList =
             from cust in context.Customers
             select cust;

         // Process each customer in the list.
         StringBuilder Output =
             new StringBuilder("Customer List:");

         // Create a customer entry for each customer.
         foreach (var Customer in CustomerList)
            Output.Append("\r\n" + Customer.ToFormattedString());

         // Display the result on screen.
         MessageBox.Show(Output.ToString());
      }

      private void btnQuery3_Click(object sender, EventArgs e)
      {
         // Create the context.
         Rewards2ModelContainer context = new Rewards2ModelContainer();

         // Obtain the customer list.
         var CustomerList =
             from cust in context.Customers
             select cust;

         // Process each customer in the list.
         StringBuilder Output =
             new StringBuilder("Customer List:");

         foreach (var Customer in CustomerList)
         {
            // Create a customer entry for each customer.
            Output.Append("\r\n" + Customer.CustomerName +
                " has made these purchases: ");

            // Process each purchase for that particular customer.
            foreach (var Purchase in Customer.Purchases)
               Output.Append("\r\n\t" + Purchase.PurchaseDate +
                  " for $" + Purchase.Amount.ToString());

            // Add the purchase total.
            Output.Append("\r\nwith a total of: $" + Customer.PurchaseTotal);
         }

         // Display the result on screen.
         MessageBox.Show(Output.ToString());
      }
   }
}
