﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace TestModelFirst
{
   using System;
   using System.Data.Entity;
   using System.Data.Entity.Infrastructure;

   // Added to handle events.
   using System.Data.Objects;
   using System.Windows.Forms;

   public partial class Rewards2ModelContainer : DbContext
   {
      public Rewards2ModelContainer()
         : base("name=Rewards2ModelContainer")
      {
         // Add an event handler for the ObjectMaterialized event.
         ((IObjectContextAdapter)this).ObjectContext.ObjectMaterialized +=
             this.ObjectContext_OnObjectMaterialized;
      }

      // Create properties to access the POCO classes.
      public DbSet<Customers> Customers { get; set; }
      public DbSet<Purchases> Purchases { get; set; }

      // Define an event handler for the ObjectMaterialized event.
      public void ObjectContext_OnObjectMaterialized(
         object sender, ObjectMaterializedEventArgs e)
      {
         // Verify the type is correct.
         if (sender.GetType() == typeof(ObjectContext))

            // Display messages only for customers.
            if (e.Entity.GetType().BaseType == typeof(Customers))

               // Display a status message.
               MessageBox.Show(((ObjectContext)sender).DefaultContainerName +
                  " has materialized " + e.Entity.ToString() + " for " +
                  ((Customers)e.Entity).CustomerName + ".");
      }
   }
}
